// setup the ADC and enter the results of the conversion into the table

#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include "data.h"

// setup the ADC at startup
void setupADC(void)
{
   // internal vref, disconnected from AREF-pin, input ADC3
   ADMUX = (1<<REFS1) | (1<<REFS2) | (1<<MUX0) | (1<<MUX1);
   
   // disconnect digital input from ADC3
   DIDR0 = (1<<ADC3D);
   
   // enable ADC, enable ADC-IRQ, prescaler 128
   ADCSRA = (1<<ADEN) | (1<<ADIE) | (1<<ADPS0) | (1<<ADPS1) | (1<<ADPS2);
}

// ADC-ISR: Save current conversion result somewhere to lambda-table
ISR(ADC_vect)
{
   static uint8_t index;
   if((++index) >= LAMBDA_TABLE_SIZE)
     {
	index = 0;
	flags |= (1<<LAMBDA_TABLE_FILLED);
     }
   lambda[index] = (uint8_t) (ADC / 2);
   //debugging
//   PORTB = (uint8_t) (ADC / 64);
}
