// setup timers
// plus IRQ-routines for times

#include <avr/io.h>
#include <avr/interrupt.h>

// setup timers - for use at startup
inline void setupTimers()
{
   // Setup TIMER0 for generating overflow IRQs
   // One per 40.96 ms
   TCCR0A = 0x00;
   // Prescaler 1024
   TCCR0B = (1<<CS02) | (1<<CS00);
   // TIMER0 Overflow IRQ enable
   TIMSK = (1<<TOIE0);
}

ISR(TIM0_OVF_vect)
{
   // start ADC conversion cycle
   // 
   // ADC NEEDS TO BE ENABLED FOR THIS
   ADCSRA |= (1<<ADSC);
}
